package net.jaekl.cfb.db;

import java.util.ArrayList;

import static org.junit.Assert.*;

public class TableMock extends Table {

	private ArrayList<Row> m_rows;
	
	public TableMock(String name, Column[] columns) {
		super(name, columns);
		m_rows = new ArrayList<Row>();
	}
	
	public TableMock(Table table) {
		this(table.m_name, table.m_columns.toArray(new Column[table.m_columns.size()]));
	}
	
	protected ArrayList<Row> mock_getRows() { return m_rows; }

	public boolean mock_hasColumn(Column expectedCol) {
		for (Column col : m_columns) {
			if (col.equals(expectedCol)) {
				return true;
			}
		}
		return false;
	}
	
	public Column[] mock_getColumns() { 
		return m_columns.toArray(new Column[m_columns.size()]);
	}
	
	public void mock_insert(Row row) {
		assertEquals(getNumColumns(), row.getNumColumns());
		for (int i = 0; i < getNumColumns(); ++i) {
			assertEquals(getColumn(i).getType(), row.getColumn(i).getType());
		}
		m_rows.add(row);
	}
}
